*! version 1.2 4/23/2001
program define mctest
  version 7.0
  syntax varlist [, Centile(integer 25) Generate(string) CORrect(string) DELete ]
  tempvar tc ic ia hi lo mid
  quietly gen `tc' = 0 in 3/l
  quietly gen `ic' = 0 in 3/l
  quietly gen `ia' = 0 in 3/l
  label variable `tc' "Total Correct"
  quietly count
  local n = r(N) - 2
  local nitem : word count `varlist'
  tokenize `varlist'
  while "`1'" ~= ""{
    quietly replace `ic' = `1'==`1'[1]
    quietly replace `tc' = `tc' + `ic' in 3/l
    macro shift
  }

  local ll = `centile'
  local ul = 100 - `ll'
  quietly centile `tc', centile(`ll' `ul')
  if "`generate'" ~= "" {
    quietly gen `generate' = `tc' in 3/l
  }
  quietly gen `hi' = `tc' >= r(c_2) in 3/l
  quietly gen `lo' = `tc' <= r(c_1) in 3/l
  quietly count if `hi' in 3/l
  local nh = r(N)
  quietly count if `lo' in 3/l
  local nl = r(N)
  quietly gen `mid' = 1 - `lo' - `hi' in 3/l
  quietly count if `mid'
  local nm = r(N) 
  local n2 = max(`nl', `nh')
  
  display
  display as txt "Multiple Choice Item Statistics"
  display  as txt "Number of items: " as res `nitem' /*
  */ as txt  "  Number of observations: " as res "`n'"
  local note "(Note: point biserials computed with item included)"
  if "`delete'" ~= "" {
    local note "(Note: point biserials computed with item deleted)" 
  }
  display as txt "`note'"
  display as txt "{hline 70}"
  display as txt "          Prop    Disc    Point        Prop       Proportion     Point"
  display as txt "Item     Correct  Index   Biser   Alt  Total   Low   Mid   High  Biser"
  display as txt "{hline 70}"
  tokenize `varlist'
  while "`1'" ~= "" {
    quietly count if `1'==`1'[1] in 3/l
    local pc = r(N)/`n'
    quietly count if `1'==`1'[1] & `hi' in 3/l
    local h = r(N)
    quietly count if `1'==`1'[1] & `lo' in 3/l
    local l = r(N)
    local dis = `h'/`nh' -`l'/`nl'
    quietly count if `1'== 1 in 3/l
    local pc1 = r(N)/`n'
    quietly count if `1'== 1 & `hi' in 3/l
    local pch = r(N)/`nh'
    quietly count if `1'== 1 & `lo' in 3/l
    local pcl = r(N)/`nl'
    quietly count if `1'== 1 & `mid' in 3/l
    local pcm = r(N)/`nm'
    local key " "
    if `1'[1] == 1 {
      local key "*"
    }
    quietly replace `ic' = `1'==`1'[1]
    if "`correct'" ~= "" {
      quietly gen `correct'`1' = `ic' in 3/l
      quietly replace `correct'`1' = 1 in 1
      quietly replace `correct'`1' = 2 in 2
    }
    quietly replace `ia' = `tc'
    if "`delete'" ~= "" {
      quietly replace `ia' = `tc' - `ic'
    }
    quietly corr `ic' `ia'
    local pbt = r(rho)
    if r(rho)==. {local pbt = 0}
    quietly replace `ic' = `1'==1
    quietly corr `ic' `ia'
    local pbi = r(rho)
    if r(rho)==. {local pbi = 0}
    display as txt %-9s "`1'" as res %4.2f `pc' %9.2f `dis' %8.2f  `pbt' /*
    */ _col(35) " 1 " %6.2f `pc1' _col(44) as txt "`key'" as res %7.2f `pcl' /* 
    */ %6.2f `pcm' %6.2f `pch' %6.2f `pbi'
    
    local na = `1'[2]
    local i = 2
    while `i' <= `na' {
      local key  " "
      if `1'[1] == `i' {
        local key "*"
      }
      quietly count if `1' == `i' in 3/l
      local pca = r(N)/`n'
      quietly count if `1'== `i' & `hi' in 3/l
      local pch = r(N)/`nh'
      quietly count if `1'== `i' & `lo' in 3/l
      local pcl = r(N)/`nl'
      quietly count if `1'== `i' & `mid' in 3/l
      local pcm = r(N)/`nm'
      quietly replace `ic' = `1'==`i'
      quietly corr `ic' `ia'
      local pbi = r(rho)
      if r(rho)==. {local pbi = 0}
      display _col(35) " `i' " %6.2f `pca'  _col(44) as txt "`key'" /*
      */ as res %7.2f `pcl' %6.2f `pcm' %6.2f `pch' %6.2f `pbi'
      local i = `i' + 1
    }
    quietly count if `1' == . in 3/l
    local pcm = r(N)/`n'
    quietly count if `1'== . & `hi' in 3/l
    local pch = r(N)/`n'
    quietly count if `1'== . & `lo' in 3/l
    local pcl = r(N)/`n'
    quietly count if `1'== . & `mid' in 3/l
    local pcm = r(N)/`nm'
    display  _col(35) " . " %6.2f `pcm' _skip(1) %7.2f `pcl' %6.2f `pcm' %6.2f `pch'
    
    quietly count if ~(`1' >= 1 & `1' <= `na') & `1' ~= . in 3/l
    local pcm = r(N)/`n'
    quietly count if ~(`1' >= 1 & `1' <= `na') & `1' ~= . & `hi' in 3/l
    local pch = r(N)/`n'
    quietly count if ~(`1' >= 1 & `1' <= `na') & `1' ~= . & `lo' in 3/l
    local pcl = r(N)/`n'
    quietly count if ~(`1' >= 1 & `1' <= `na') & `1' ~= . & `mid' in 3/l
    local pcm = r(N)/`nm'
    display  _col(34) "Other" %5.2f `pcm' _skip(1) %7.2f `pcl' %6.2f `pcm' %6.2f `pch'
    macro shift
    display
  }
end
